.586    
.model flat,stdcall
option casemap:none

WinMain PROTO   :DWORD,:DWORD,:DWORD,:DWORD
CreateMainControls  PROTO   :DWORD

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\gdi32.inc
include \masm32\include\comctl32.inc
include \masm32\include\comdlg32.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\comctl32.lib
includelib \masm32\lib\comdlg32.lib

.const

MainWindowWidth     equ     600
MainWindowHeight    equ     350

NoROP2Strings       equ     15
PARAM_CREATE        equ      0
NoTBDrawButtons     equ      3
NoTBPenButtons      equ      3    
NoImages            equ      6

TBDrawID            equ      100h
TBPenID             equ      200h

.data

hInstance       dd      ?
hMainWindow     dd      ?
MainWindowClass db      'MainWindowClass',0
MainWindowName  db      'GDI Example 1',0

wc          WNDCLASSEX  <sizeof wc,NULL,offset WndProc,NULL,NULL,NULL, \
                        NULL,NULL,COLOR_WINDOW,NULL,offset MainWindowClass,NULL>

; ++++ Combo related +++++

hCombo      dd      ?
ComboClass  db      'COMBOBOX',0
ROP2Strings     db      'R2_BLACK',0
                db      'R2_COPYPEN',0
                db      'R2_MASKNOTPEN',0
                db      'R2_MASKPEN',0
                db      'R2_MASKPENNOT',0
                db      'R2_MERGENOTPEN',0
                db      'R2_MERGEPEN',0
                db      'R2_MERGEPENNOT',0
                db      'R2_NOP',0
                db      'R2_NOT',0
                db      'R2_NOTCOPYPEN',0
                db      'R2_NOTMASKPEN',0
                db      'R2_NOTXORPEN',0
                db      'R2_WHITE',0
                db      'R2_XORPEN',0
ROP2Types       dd      R2_BLACK
                dd      R2_COPYPEN
                dd      R2_MASKNOTPEN
                dd      R2_MASKPEN
                dd      R2_MASKPENNOT
                dd      R2_MERGENOTPEN
                dd      R2_MERGEPEN
                dd      R2_MERGEPENNOT
                dd      R2_NOP
                dd      R2_NOT
                dd      R2_NOTCOPYPEN
                dd      R2_NOTMASKPEN
                dd      R2_NOTXORPEN
                dd      R2_WHITE
                dd      R2_XORPEN

; ++++ Button related ++++

ButtonClass     db      'BUTTON',0
hBtn            dd          ?

; ++++ MDI related ++++

MdiClientClass  db      'MDICLIENT',0
MdiChildClass   db      'MdiChild',0
hMdiClient      dd          ?
hMdi            dd          ?
MdiClientName   db      'MdiClientName',0

; ++++ ReBar Control related +++++

ReBarClass      db      'ReBarWindow32',0
hRBVert         dd          ?
hRBHorz         dd          ?
rbbi            REBARBANDINFO       <>

; ++++ Toolbar related ++++

ToolbarClass    db      'ToolbarWindow32',0
hTbDraw         dd          ?
TBDrawButtons       TBBUTTON    <0,0,TBSTATE_ENABLED,BTNS_CHECKGROUP,NULL,NULL>
                TBBUTTON    <1,1,TBSTATE_ENABLED,BTNS_CHECKGROUP,NULL,NULL>
                TBBUTTON    <2,2,TBSTATE_ENABLED,BTNS_CHECKGROUP,NULL,NULL>
hTbPen          dd          ?
TBPenButtons    TBBUTTON    <3,10,TBSTATE_ENABLED+TBSTATE_CHECKED,BTNS_CHECKGROUP,NULL,NULL>                
                TBBUTTON    <5,11,TBSTATE_ENABLED,BTNS_CHECKGROUP,NULL,NULL>
                TBBUTTON    <4,12,TBSTATE_ENABLED,TBSTYLE_BUTTON,NULL,NULL>                
                
; ++++ Other Vars ++++

iccx        INITCOMMONCONTROLSEX    <sizeof iccx,ICC_BAR_CLASSES+ICC_COOL_CLASSES+ICC_STANDARD_CLASSES>
rect        RECT        <>

; ++++ DC's ,Colors, Pen ++++

ColorArray      dd 00000000h,00aa0000h,0000aa00h,00aaaa00h
              dd 000000aah,00aa00aah,000055aah,00aaaaaah
              dd 00555555h,00ff5555h,0055ff55h,00ffff55h
              dd 005555ffh,00ff55ffh,0055ffffh,00ffffffh

ChooseColorName db      'Choose Color',0
cc          CHOOSECOLOR     <sizeof cc,?,?,80h,offset ColorArray,0,0,0,0> 
hDC         HDC             ?
hMemDC      HDC             ?
hBitmap     dd              ?
hBitmapMask dd              ?
hIml        dd              ?
hPen        dd              ?
PenSize     dd              3
point       POINT               <>
ccst        CLIENTCREATESTRUCT        <0,0>
mdics       MDICREATESTRUCT           <>
szUntitled  db              'Untitled Document',0
                        
.code
    start:
        invoke  GetModuleHandle,NULL
        mov     hInstance,eax
        invoke  InitCommonControlsEx,addr iccx
        invoke  WinMain,hInstance,NULL,NULL,SW_SHOWNORMAL
        invoke  ExitProcess,eax


WinMain PROC    hInst:DWORD,hPInst:DWORD,CmdLine:DWORD,CmdShow:DWORD

    local   msg:MSG

    push    hInstance
    pop     wc.hInstance
    invoke  LoadIcon,NULL,IDI_APPLICATION
    mov     wc.hIcon,eax
    mov     wc.hIconSm,eax
    invoke  LoadCursor,NULL,IDC_ARROW
    mov     wc.hCursor,eax
    invoke  RegisterClassEx,addr wc
    invoke  GetSystemMetrics,SM_CYSCREEN
    shr     eax,1
    sub     eax,MainWindowHeight/2
    push    eax
    invoke  GetSystemMetrics,SM_CXSCREEN
    shr     eax,1
    sub     eax,MainWindowWidth/2
    pop     ebx
    invoke  CreateWindowEx,NULL,addr MainWindowClass,addr MainWindowName,WS_TILEDWINDOW+WS_CLIPCHILDREN+WS_CLIPSIBLINGS,\   
               eax,ebx,MainWindowWidth,MainWindowHeight,NULL,NULL,hInstance,NULL
    mov     hMainWindow,eax
    invoke  ShowWindow,eax,CmdShow
    invoke  UpdateWindow,hMainWindow

msg_loop:
    invoke  GetMessage,addr msg,NULL,0,0
    or      eax,eax
    jz      end_msg_loop
    invoke  TranslateMessage,addr msg
    invoke  DispatchMessage,addr msg
    jmp     msg_loop
end_msg_loop:
    mov     eax,msg.wParam
    ret

WinMain     endp

WndProc PROC    hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    local   hx:DWORD
       
    .if uMsg==WM_DESTROY
        invoke  PostQuitMessage,NULL

    .elseif	uMsg==WM_CREATE
		mov		edi,lParam
		.if	[edi.CREATESTRUCT].hWndParent==NULL
                invoke  CreateMainControls,hWnd
                push    hWnd
                pop     cc.hwndOwner
                push    hInstance
                pop     cc.hInstance
 		.endif
    .elseif uMsg==WM_COMMAND
        mov     eax,wParam
        .if     eax==12
            invoke  ChooseColor,addr cc
            invoke  SendMessage,hTbPen,TB_ISBUTTONCHECKED,10,NULL
            .if     eax==0
                invoke  CreatePen,PS_SOLID,PenSize,cc.rgbResult
            .else
                invoke  CreatePen,PS_SOLID,1,cc.rgbResult
            .endif      
                mov     hPen,eax
                invoke  SelectObject,hMemDC,hPen    
        .endif            
 ;     .elseif uMsg==WM_SIZE
 ;         invoke  SendMessage,hRBHorz,RB_GETBARHEIGHT,NULL,NULL
 ;         mov     hx,eax
 ;         mov     eax,wParam
 ;         mov     ebx,eax
 ;         movzx   eax,ax
 ;         shr     ebx,16
 ;         sub     ebx,30
 ;         invoke  MoveWindow,hMdiClient,0,hx,eax,ebx,TRUE
    .else
        invoke  DefWindowProc,hWnd,uMsg,wParam,lParam
        ret
    .endif
    xor eax,eax
    ret

WndProc     endp

MdiProc     PROC    hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    local   ps:PAINTSTRUCT
    local   hBmp:DWORD
    local   hx:DWORD
       
    .if     uMsg==WM_MDIDESTROY
        invoke  SendMessage,hWnd,WM_SYSCOMMAND,SC_CLOSE,NULL
    .elseif uMsg==WM_CREATE
        invoke  GetClientRect,hWnd,addr rect
        invoke  GetDesktopWindow
        push    eax
        invoke  GetDC,eax
        mov     hDC,eax
        invoke  CreateCompatibleDC,hDC
        mov     hMemDC,eax
        invoke  CreatePen,PS_SOLID,4,0ff00h
        mov     hPen,eax
        invoke  GetSystemMetrics,SM_CYSCREEN
        push    eax
        invoke  GetSystemMetrics,SM_CXSCREEN
        pop     ebx
        invoke  CreateCompatibleBitmap,hMemDC,eax,ebx
        invoke  SelectObject,hMemDC,eax
        invoke  DeleteObject,eax
        pop     eax
        invoke  ReleaseDC,eax,hDC
        invoke  BitBlt,hMemDC,0,0,1000,1000,hMemDC,0,0,PATPAINT
 
    .elseif uMsg==WM_PAINT
        invoke  BeginPaint,hWnd,addr ps
		mov edx,ps.rcPaint.right
		sub edx,ps.rcPaint.left
		mov ecx,ps.rcPaint.bottom
		sub ecx,ps.rcPaint.top
  
        invoke  BitBlt,ps.hdc,ps.rcPaint.left,ps.rcPaint.top,edx,ecx,\
                          hMemDC,ps.rcPaint.left,ps.rcPaint.top,SRCCOPY
        invoke  EndPaint,hWnd,addr ps
        
    .elseif uMsg==WM_LBUTTONDOWN
    
        invoke  SelectObject,hMemDC,hPen
        mov     eax,lParam
        mov     ebx,eax
        movzx   eax,ax
        shr     ebx,16
        invoke  LineTo,hMemDC,eax,ebx
        invoke  GetClientRect,hWnd,addr rect
        invoke  InvalidateRect,hWnd,addr rect,TRUE
  ;    .elseif uMsg==WM_SIZE
 ;         invoke  SendMessage,hRBHorz,RB_GETBARHEIGHT,NULL,NULL
 ;         mov     hx,eax
 ;         mov     eax,wParam
 ;         mov     ebx,eax
 ;         movzx   eax,ax
 ;         shr     ebx,16
 ;         sub     ebx,30
 ;         invoke  MoveWindow,hMdiClient,0,hx,eax,ebxUE

    .else
        invoke  DefMDIChildProc,hWnd,uMsg,wParam,lParam
        ret
    .endif        
    xor eax,eax
    ret

MdiProc     endp                        

CreateMainControls  PROC    hWnd:DWORD

; ++++ Rebar Controls Creation ++++

    invoke  CreateWindowEx,NULL,addr ReBarClass,NULL,WS_VISIBLE+WS_CHILD+RBS_AUTOSIZE+\
                WS_CLIPCHILDREN+WS_CLIPSIBLINGS,\
                0,0,CW_USEDEFAULT,CW_USEDEFAULT,hWnd,NULL,hInstance,NULL
    mov     hRBHorz,eax                

; ++++  ImageList Creation ++++

    invoke  ImageList_Create,20,20,ILC_COLOR32+ILC_MASK,6,6
    mov     hIml,eax

; ++++ Draw Toolbar Creation ++++

    invoke  CreateWindowEx,NULL,addr ToolbarClass,NULL,WS_VISIBLE+WS_CHILD+TBSTYLE_FLAT+CCS_NODIVIDER+CCS_NOPARENTALIGN+CCS_NORESIZE,\
                    0,0,80,26,hWnd,NULL,TBDrawID,NULL
    mov     hTbDraw,eax                              
    invoke  SendMessage,hTbDraw,TB_SETIMAGELIST,NULL,hIml
    call    CreateImageList
    invoke  SendMessage,hTbDraw,TB_BUTTONSTRUCTSIZE,sizeof TBBUTTON,NULL
    invoke  SendMessage,hTbDraw,TB_ADDBUTTONS,NoTBDrawButtons,addr TBDrawButtons
    invoke  SendMessage,hTbDraw,TB_AUTOSIZE,NULL,NULL
    mov     rbbi.cbSize,sizeof rbbi
    mov     rbbi.fMask,RBBIM_CHILD+RBBIM_SIZE+RBBIM_STYLE+RBBIM_CHILDSIZE
    mov     rbbi.fStyle,RBBS_GRIPPERALWAYS+RBBS_TOPALIGN+RBBS_FIXEDSIZE
    push    hTbDraw
    pop     rbbi.hwndChild
    mov     rbbi.lx,60
    mov     rbbi.cxMinChild,80
    mov     rbbi.cyMinChild,26
    mov     rbbi.cyChild,26
    mov     rbbi.cyIntegral,10
    mov     rbbi.lpText,offset MainWindowName
    invoke  SendMessage,hRBHorz,RB_INSERTBAND,0,addr rbbi

; ++++ Pen Toolbar Creation ++++

    invoke  CreateWindowEx,NULL,addr ToolbarClass,NULL,WS_VISIBLE+WS_CHILD+TBSTYLE_FLAT+CCS_NODIVIDER+CCS_NOPARENTALIGN+CCS_NORESIZE,\
                    0,0,40,26,hWnd,TBPenID,hInstance,NULL        
    mov     hTbPen,eax
    invoke  SendMessage,hTbPen,TB_SETIMAGELIST,NULL,hIml
    invoke  SendMessage,eax,TB_BUTTONSTRUCTSIZE,sizeof TBBUTTON,NULL
    invoke  SendMessage,hTbPen,TB_ADDBUTTONS,NoTBPenButtons,addr TBPenButtons
    invoke  SendMessage,hTbPen,TB_AUTOSIZE,NULL,NULL
    mov     rbbi.fStyle,RBBS_GRIPPERALWAYS
    push    hTbPen
    pop     rbbi.hwndChild
    mov     rbbi.lx,80
    mov     rbbi.cxMinChild,80
    mov     rbbi.cyMinChild,26
    mov     rbbi.cyChild,26    
    mov     rbbi.cyIntegral,10    
    invoke  SendMessage,hRBHorz,RB_INSERTBAND,1,addr rbbi

; ++++ MDI Client Creation ++++
    invoke  GetClientRect,hWnd,addr rect
    invoke  SendMessage,hRBHorz,RB_GETBARHEIGHT,NULL,NULL
    add     eax,4
    sub     rect.bottom,eax
    add     rect.top,eax
    invoke  CreateWindowEx,NULL,addr MdiClientClass,NULL,WS_VISIBLE+WS_CHILD,\
                    0,rect.top,rect.right,rect.bottom,hWnd,0300h,hInstance,addr ccst
    mov     hMdiClient,eax 
    mov     wc.style,CS_OWNDC
    mov     wc.lpszClassName,offset MdiChildClass
    mov     wc.lpfnWndProc,offset MdiProc
    invoke  GetStockObject,WHITE_BRUSH
    mov     wc.hbrBackground,eax
    invoke  RegisterClassEx,addr wc  
    invoke  CreateWindowEx,WS_EX_MDICHILD,addr MdiChildClass,addr szUntitled,MDIS_ALLCHILDSTYLES,\
                0,0,200,200,hMdiClient,NULL,hInstance,PARAM_CREATE   
    mov     hMdi,eax
    ret

CreateMainControls  endp

CreateImageList PROC

    mov     esi,100
    mov     ecx,NoImages
looper:    
    push    ecx
    invoke  LoadBitmap,hInstance,esi
    mov     hBitmap,eax
    inc     esi
    invoke  LoadBitmap,hInstance,esi
    mov     hBitmapMask,eax
    inc     esi
    invoke  ImageList_Add,hIml,hBitmap,eax
    invoke  DeleteObject,hBitmap
    invoke  DeleteObject,hBitmapMask
    pop     ecx
    dec     ecx
    jcxz    end_looper
    jmp     looper
end_looper:
    ret

CreateImageList endp    
    
end start
